import java.util.*;

public class AdjList
{
  private LinkedList adjacencies[]; // List of LinkedLists, by vertex no.
  private int inDegree[]; // Indegree, by vertex number
  private int numVertices; // Number of Verticies in graph

   
  /*
   * This exception is thrown in the event that a topologicalSort()
   * is unable to remove all items from the Graph
   */
  public class UnsatisfiedException extends Exception
  {
    public UnsatisfiedException(String string)
    {
      super(string);
    }
  }


 /*
  * A very basic constructor that creates an empty graph
  * of up to _size_ verticies
  */ 
  public AdjList(int size)
  {
    numVertices = size;
    adjacencies = new LinkedList[size];
    inDegree = new int[size];

    for (int vertexIndex = 0; vertexIndex < size; vertexIndex++)
      adjacencies[vertexIndex] = new LinkedList();
  }


  /*
   * This is a copy constructor. It copies the supplied AdjList
   * to initialize the new one
   */
  public AdjList(AdjList adjList)
  {
      adjacencies = new LinkedList[adjList.numVertices];
      numVertices = adjList.numVertices;
      inDegree = adjList.inDegree;
      for (int i = 0; i < numVertices; i++)
          adjacencies[i] = (LinkedList)adjList.adjacencies[i].clone();
  }


  /*
   * WRITE THIS METHOD; WRITE THIS METHOD; WRITE THIS METHOD
   *
   * This method adds an Edge to the Graph, adjusting the
   * adjacency list, proper, and also the inDegree array. 
   *
   * WRITE THIS METHOD; WRITE THIS METHOD; WRITE THIS METHOD
   */
  public void addEdge(Edge edge)
  {
    /*
     * Your code here
     */
  }


  /*
   * This returns the Verticies adjacent to the requested Vertex
   * in a ListIterator. This list is a list of Integer objects
   * representing the vertex numbers
   */
  public ListIterator getAdjacencies(int vertexNumber)
  {
      return adjacencies[vertexNumber].listIterator();
  }


  /*
   * A simple accessor that returns the total number of Verticies
   * in the Graph
   */
  public int getCount()
  {
      return numVertices;
  }


  /*
   * WRITE THIS METHOD; WRITE THIS METHOD; WRITE THIS METHOD
   *
   * A simple accessor that returns an Edge, given an Edge. 
   * This might not make sense initially, but it can be used to get the
   * weight of an Edge in an weighted graph, since it returns 
   * the Edge from the Graph, given an Edge passed in that need only
   * match in start and finish verticies, not weight.
   * in the Graph
   *
   * WRITE THIS METHOD; WRITE THIS METHOD; WRITE THIS METHOD
   */
  public Edge getEdge(Edge edge)
  {
    /*
     * Your code here
     */
  }


  /*
   * WRITE THIS METHOD; WRITE THIS METHOD; WRITE THIS METHOD
   *
   * This removes an Edge from the graph, adjusting both the
   * basic adjacency list structure and also the indegree array.
   *
   * WRITE THIS METHOD; WRITE THIS METHOD; WRITE THIS METHOD
   */
  public void removeEdge(Edge edge)
  {
    /*
     * Your code here
     */
  }


  /*
   * The classic toString() method. A big ugly, but it gets the job done.
   */
  public String toString()
  {
    String string = "";
    for (int vertexNumber = 0; vertexNumber < numVertices; vertexNumber++)
    {
      string = vertexNumber + ": " + adjacencies[vertexNumber].toString() + 
               "\n";
    }

    return string;
  }


  /*
   * WRITE THIS METHOD; WRITE THIS METHOD; WRITE THIS METHOD
   *
   * This method should perform a topological sort of the graph.
   *
   * Upon normal completion, the graph should be empty and all of the
   * verticies should be in the returned LinkedList, in the sorted 
   * order from head (first) to tail (last). The verticies should be
   * represented by vertex number as an Integer.
   *
   * If the graph cannot be sorted, such as due to a cycle,
   * an UnsatisfiedException should be thrown. The graph should
   * contain only the unsatisfiable dependencies, e.g. those
   * verticies involved in cycles.
   * 
   *
   * WRITE THIS METHOD; WRITE THIS METHOD; WRITE THIS METHOD
   */
  public LinkedList topologicalSort()
      throws UnsatisfiedException
  {
     /*
      * Your code here
      */
  }
}
